
Перем Лог;

///////////////////////////////////////////////////////////////////////////////////////////////////
// Прикладной интерфейс

Процедура ЗарегистрироватьКоманду(Знач ИмяКоманды, Знач Парсер) Экспорт
	ОписаниеКоманды = Парсер.ОписаниеКоманды(ИмяКоманды, "Создание файлов поставки (cf и cfu)");
	Парсер.ДобавитьИменованныйПараметрКоманды(ОписаниеКоманды, "-cfu-basedir", "Каталог предыдущих версий для создания CFU (опционально)");
    Парсер.ДобавитьИменованныйПараметрКоманды(ОписаниеКоманды, "-update-from", "Перечень версий, через запятую, включаемых в обновление (опционально)");

	Парсер.ДобавитьКоманду(ОписаниеКоманды);
КонецПроцедуры

// Выполняет логику команды
// 
// Параметры:
//   ПараметрыКоманды - Соответствие ключей командной строки и их значений
//
Функция ВыполнитьКоманду(Знач ПараметрыКоманды) Экспорт
    
	СоздатьФайлыКонфигурацииПоставщика(ОкружениеСборки.ПолучитьКонфигуратор(), ПараметрыКоманды["-cfu-basedir"], ПараметрыКоманды["-update-from"]);

КонецФункции

Функция СоздатьФайлыКонфигурацииПоставщика(Знач УправлениеКонфигуратором, Знач КаталогВерсий, Знач ПредыдущиеВерсии) Экспорт
    ИмяФайлаПоставки = УправлениеКонфигуратором.КаталогСборки() + "\1cv8.cf";
	Параметры = УправлениеКонфигуратором.ПолучитьПараметрыЗапуска();
	Параметры.Добавить("/CreateDistributionFiles");
	Параметры.Добавить("-cffile """+ИмяФайлаПоставки+"""");
	
	ФайлыПредыдущихВерсий = НайтиФайлыПредыдущихВерсий(КаталогВерсий, ПредыдущиеВерсии);
	Если ФайлыПредыдущихВерсий <> Неопределено Тогда
		ИмяФайлаОбновления = УправлениеКонфигуратором.КаталогСборки() + "\1cv8.cfu";
		Параметры.Добавить("-cfufile """+ИмяФайлаОбновления+"""");
		
		Для Каждого ФайлПредыдущейВерсии Из ФайлыПредыдущихВерсий Цикл
			Лог.Информация("Добавляю обновление из файла: " + ФайлПредыдущейВерсии.ПолноеИмя);
			Параметры.Добавить("-f """ + ФайлПредыдущейВерсии.ПолноеИмя + """");
		КонецЦикла;
		
	КонецЕсли;
	
	УправлениеКонфигуратором.ВыполнитьКоманду(Параметры);
	Сообщить(УправлениеКонфигуратором.ВыводКоманды());
    
    Возврат Новый Структура("ИмяФайлаПоставки,ИмяФайлаОбновления", ИмяФайлаПоставки, ИмяФайлаОбновления);
    
КонецФункции // СоздатьФайлыКонфигурацииПоставщика()

Функция НайтиФайлыПредыдущихВерсий(Знач КаталогПредыдущихВерсий, Знач ВерсииОбновления)
	
	Если КаталогПредыдущихВерсий = Неопределено Тогда
		Возврат Неопределено;
	КонецЕсли;
	
	Каталог = Новый Файл(КаталогПредыдущихВерсий);
	Если Не Каталог.Существует() Тогда
		Возврат Неопределено;
	КонецЕсли;
	
	ФайлыКонфигураций = Новый Массив;
	
	Для Каждого Версия Из ВерсииОбновления Цикл
		КаталогВерсии = Новый Файл(ОбъединитьПути(КаталогПредыдущихВерсий, Версия));
		Если Не КаталогВерсии.Существует() Тогда
			Текст = СтрШаблон("Каталог версии %1 не найден", КаталогВерсии.ПолноеИмя);
			Лог.Ошибка(Текст);
			ВызватьИсключение Текст;
		КонецЕсли;
		
		ФайлыКонфигурацийВерсии = НайтиФайлы(КаталогВерсии, "*.cf", Истина);
		Для Каждого ФайлВерсии Из ФайлыКонфигурацийВерсии Цикл
			ФайлыКонфигураций.Добавить(ФайлВерсии);
		КонецЦикла;
	КонецЦикла;
	
	Если ФайлыКонфигураций.Количество() Тогда
		Возврат ФайлыКонфигураций;
	Иначе
		Возврат Неопределено;
	КонецЕсли;
КонецФункции

Функция РазобратьПараметры(Знач ПараметрыКоманды) Экспорт
    
    Результат = Новый Структура;
    Результат.Вставить("КаталогВерсий", ПараметрыКоманды["-cfu-basedir"]);
    
    МассивВерсий = СтроковыеФункции.РазложитьСтрокуВМассивПодстрок(
        Строка(ПараметрыКоманды["-update-from"]),
        ",",
        Ложь,
        Истина);
    
    Результат.Вставить("ПредыдущиеВерсии", МассивВерсий);
    
    
    Возврат Результат;
    
КонецФункции

//////////////////////////////////////////////////////////////////////////
//

Лог = Логирование.ПолучитьЛог(ПараметрыСистемы.ИмяЛогаСистемы());